/*
 * 助利宝兑换明细
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class HelpProfitExchangeDetailController : BaseController
    {
        public HelpProfitExchangeDetailController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 助利宝兑换明细列表

        /// <summary>
        /// 根据条件查询助利宝兑换明细列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(HelpProfitExchangeDetail data, string right, string RecordId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.RecordId = RecordId;


            return View();
        }

        #endregion

        #region 根据条件查询助利宝兑换明细列表

        /// <summary>
        /// 助利宝兑换明细列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(HelpProfitExchangeDetail data, string UserIdMakerCode, string UserIdRealName, string PosCouponIdSelect, string CreateDateData, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();
            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //券码
            if (!string.IsNullOrEmpty(PosCouponIdSelect))
            {
                condition += " and PosCouponId=" + PosCouponIdSelect;
            }
            if (!string.IsNullOrEmpty(CreateDateData))
            {
                string[] datelist = CreateDateData.Split(new string[] { " - " }, StringSplitOptions.None);
                string start = datelist[0];
                string end = datelist[1];
                condition += " and CreateDate>='" + start + " 00:00:00' and CreateDate<='" + end + " 23:59:59'";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitExchangeDetail", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加助利宝兑换明细

        /// <summary>
        /// 增加或修改助利宝兑换明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right, string RecordId)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.RecordId = RecordId;


            return View();
        }

        #endregion

        #region 增加助利宝兑换明细

        /// <summary>
        /// 增加或修改助利宝兑换明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(HelpProfitExchangeDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("RecordId", data.RecordId);

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("PosCouponId", data.PosCouponId); //券码
            Fields.Add("ExchangeCode", data.ExchangeCode); //兑换券码

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("HelpProfitExchangeDetail", Fields, 0);
            AddSysLog(data.Id.ToString(), "HelpProfitExchangeDetail", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改助利宝兑换明细

        /// <summary>
        /// 增加或修改助利宝兑换明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, string RecordId, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            ViewBag.RecordId = RecordId;


            HelpProfitExchangeDetail editData = db.HelpProfitExchangeDetail.FirstOrDefault(m => m.Id == Id) ?? new HelpProfitExchangeDetail();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改助利宝兑换明细

        /// <summary>
        /// 增加或修改助利宝兑换明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(HelpProfitExchangeDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            Fields.Add("RecordId", data.RecordId);

            Fields.Add("UserId", data.UserId); //创客
            Fields.Add("PosCouponId", data.PosCouponId); //券码
            Fields.Add("ExchangeCode", data.ExchangeCode); //兑换券码

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitExchangeDetail", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "HelpProfitExchangeDetail", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除助利宝兑换明细信息

        /// <summary>
        /// 删除助利宝兑换明细信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitExchangeDetail", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitExchangeDetail", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitExchangeDetail", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitExchangeDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "HelpProfitExchangeDetail", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("HelpProfitExchangeDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("HelpProfitExchangeDetail", Sort, Id);

            AddSysLog(Id.ToString(), "HelpProfitExchangeDetail", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.HelpProfitExchangeDetail.Add(new HelpProfitExchangeDetail()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "HelpProfitExchangeDetail", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(HelpProfitExchangeDetail data, string UserIdMakerCode, string UserIdRealName, string PosCouponIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间
            Fields.Add("ExchangeCode", "1"); //兑换券码


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //券码
            if (!string.IsNullOrEmpty(PosCouponIdSelect))
            {
                condition += " and PosCouponId=" + PosCouponIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("HelpProfitExchangeDetail", Fields, "Id desc", "0", 1, 20000, condition, "UserId,PosCouponId,ExchangeCode", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //券码
                dic["PosCouponId"] = RelationClass.GetPosCouponsInfo(int.Parse(dic["PosCouponId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdRealName", "创客真实姓名");
            ReturnFields.Add("PosCouponId", "券码");
            ReturnFields.Add("ExchangeCode", "兑换券码");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "HelpProfitExchangeDetail", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
